/*
The software in this package is distributed under the GNU General
Public License version 2 (with a special exception described below).

A copy of GNU General Public License (GPL) is included in this distribution,
in the file COPYING.GPL.

As a special exception, if other files instantiate templates or use macros
or inline functions from this file, or you compile this file and link it
with other works to produce a work based on this file, this file
does not by itself cause the resulting work to be covered
by the GNU General Public License.

However the source code for this file must still be made available
in accordance with section (3) of the GNU General Public License.

This exception does not invalidate any other reasons why a work based
on this file might be covered by the GNU General Public License.
*/
#ifndef _OFTMPSTREAM_HXX
#define _OFTMPSTREAM_HXX

#include <iostream>
#include <fstream>
#include <string>

class fdoutbuf : public std::streambuf {
  protected:
    int fd;    // file descriptor
  public:
    fdoutbuf ()
        : fd(-1)
    {
    }
    void set_fd(int _fd);
  protected:
    virtual int_type overflow (int_type c);
    virtual std::streamsize xsputn (const char* s, std::streamsize num);
};

/// This class is deprecated, use I2n::tmpofcopystream instead.
class oftmpstream : public std::ostream {
public:
    oftmpstream ();
    oftmpstream (const std::string &name);
    ~oftmpstream ();
    void open (const std::string &name);
    void close();
    std::string get_filename();
    std::string get_tmp_filename();
    void set_file_mode(int mode);
private:
    int fd;
    fdoutbuf buf;
    bool is_open;
    int file_mode;

    std::string tmpname;
    std::string realname;
};


#endif
